Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.swt.widgets
Class MenuItem

    java.lang.Object
      org.eclipse.swt.widgets.Widget
          org.eclipse.swt.widgets.Item
              org.eclipse.swt.widgets.MenuItem

public class MenuItem
extends Item

Instances of this class represent a selectable user interface object that issues notification when pressed and released.

Styles:
  CHECK, CASCADE, PUSH, RADIO, SEPARATOR
Events:
  Arm, Help, Selection

Note: Only one of the styles CHECK, CASCADE, PUSH, RADIO and SEPARATOR may be specified.

IMPORTANT: This class is not intended to be subclassed.

Constructor Summary
`MenuItem(Menu parent, int style)` Constructs a new instance of this class given its parent (which must be a `Menu`) and a style value describing its behavior and appearance.
`MenuItem(Menu parent, int style, int index)` Constructs a new instance of this class given its parent (which must be a `Menu`), a style value describing its behavior and appearance, and the index at which to place it in the items maintained by its parent.

Method Summary
`void` | `addArmListener(ArmListener listener)` Adds the listener to the collection of listeners who will be notified when the arm events are generated for the control, by sending it one of the messages defined in the `ArmListener` interface.
`void` | `addHelpListener(HelpListener listener)` Adds the listener to the collection of listeners who will be notified when the help events are generated for the control, by sending it one of the messages defined in the `HelpListener` interface.
`void` | `addSelectionListener(SelectionListener listener)` Adds the listener to the collection of listeners who will be notified when the control is selected, by sending it one of the messages defined in the `SelectionListener` interface.
`protected void` | `checkSubclass()` Checks that this class can be subclassed.
`int` | `getAccelerator()` Return the widget accelerator.
`boolean` | `getEnabled()` Returns `true` if the receiver is enabled, and `false` otherwise.
`Menu` | `getMenu()` Returns the receiver's cascade menu if it has one or null if it does not.
`Menu` | `getParent()` Returns the receiver's parent, which must be a `Menu`.
`boolean` | `getSelection()` Returns `true` if the receiver is selected, and false otherwise.
`boolean` | `isEnabled()` Returns `true` if the receiver is enabled and all of the receiver's ancestors are enabled, and `false` otherwise.
`void` | `removeArmListener(ArmListener listener)` Removes the listener from the collection of listeners who will be notified when the arm events are generated for the control.
`void` | `removeHelpListener(HelpListener listener)` Removes the listener from the collection of listeners who will be notified when the help events are generated for the control.
`void` | `removeSelectionListener(SelectionListener listener)` Removes the listener from the collection of listeners who will be notified when the control is selected.
`void` | `setAccelerator(int accelerator)` Sets the widget accelerator.
`void` | `setEnabled(boolean enabled)` Enables the receiver if the argument is `true`, and disables it otherwise.
`void` | `setImage(Image image)` Sets the image the receiver will display to the argument.
`void` | `setMenu(Menu menu)` Sets the receiver's pull down menu to the argument.
`void` | `setSelection(boolean selected)` Sets the selection state of the receiver.
`void` | `setText(String string)` Sets the receiver's text.

Methods inherited from class org.eclipse.swt.widgets.Item
`getImage, getText`

Methods inherited from class org.eclipse.swt.widgets.Widget
`addDisposeListener, addListener, checkWidget, dispose, getData, getData, getDisplay, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, setData, setData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### MenuItem

    public MenuItem(Menu parent,
                    int style)

  Constructs a new instance of this class given its parent (which must be a `Menu`) and a style value describing its behavior and appearance. The item is added to the end of the items maintained by its parent.

  The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a menu control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  `SWT.CHECK`, `SWT.CASCADE`, `SWT.PUSH`, `SWT.RADIO`, `SWT.SEPARATOR`, `Widget.checkSubclass()`, `Widget.getStyle()`

### MenuItem

    public MenuItem(Menu parent,
                    int style,
                    int index)

  Constructs a new instance of this class given its parent (which must be a `Menu`), a style value describing its behavior and appearance, and the index at which to place it in the items maintained by its parent.

  The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a menu control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
  `index` - the index to store the receiver in its parent
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  `SWT.CHECK`, `SWT.CASCADE`, `SWT.PUSH`, `SWT.RADIO`, `SWT.SEPARATOR`, `Widget.checkSubclass()`, `Widget.getStyle()`

Method Detail

### addArmListener

    public void addArmListener(ArmListener listener)

  Adds the listener to the collection of listeners who will be notified when the arm events are generated for the control, by sending it one of the messages defined in the `ArmListener` interface.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `ArmListener`, `removeArmListener(org.eclipse.swt.events.ArmListener)`

### addHelpListener

    public void addHelpListener(HelpListener listener)

  Adds the listener to the collection of listeners who will be notified when the help events are generated for the control, by sending it one of the messages defined in the `HelpListener` interface.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `HelpListener`, `removeHelpListener(org.eclipse.swt.events.HelpListener)`

### addSelectionListener

    public void addSelectionListener(SelectionListener listener)

  Adds the listener to the collection of listeners who will be notified when the control is selected, by sending it one of the messages defined in the `SelectionListener` interface.

  When `widgetSelected` is called, the stateMask field of the event object is valid. `widgetDefaultSelected` is not called.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `SelectionListener`, `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`, `SelectionEvent`

### checkSubclass

    protected void checkSubclass()

  Description copied from class: `Widget`
  Checks that this class can be subclassed.

  The SWT class library is intended to be subclassed only at specific, controlled points (most notably, `Composite` and `Canvas` when implementing new widgets). This method enforces this rule unless it is overridden.

  IMPORTANT: By providing an implementation of this method that allows a subclass of a class which does not normally allow subclassing to be created, the implementer agrees to be fully responsible for the fact that any such subclass will likely fail between SWT releases and will be strongly platform specific. No support is provided for user-written classes which are implemented in this fashion.

  The ability to subclass outside of the allowed SWT classes is intended purely to enable those not on the SWT development team to implement patches in order to get around specific limitations in advance of when those limitations can be addressed by the team. Subclassing should not be attempted without an intimate and detailed understanding of the hierarchy.

  Overrides:
    `checkSubclass` in class `Item`

### getAccelerator

    public int getAccelerator()

  Return the widget accelerator. An accelerator is the bit-wise OR of zero or more modifier masks and a key. Examples: `SWT.CONTROL | SWT.SHIFT | 'T', SWT.ALT | SWT.F2`.

  Returns:
    the accelerator
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getEnabled

    public boolean getEnabled()

  Returns `true` if the receiver is enabled, and `false` otherwise. A disabled control is typically not selectable from the user interface and draws with an inactive or "grayed" look.

  Returns:
    the receiver's enabled state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `isEnabled()`

### getMenu

    public Menu getMenu()

  Returns the receiver's cascade menu if it has one or null if it does not. Only `CASCADE` menu items can have a pull down menu. The sequence of key strokes, button presses and/or button releases that are used to request a pull down menu is platform specific.

  Returns:
    the receiver's menu
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getParent

    public Menu getParent()

  Returns the receiver's parent, which must be a `Menu`.

  Returns:
    the receiver's parent
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSelection

    public boolean getSelection()

  Returns `true` if the receiver is selected, and false otherwise.

  When the receiver is of type `CHECK` or `RADIO`, it is selected when it is checked.

  Returns:
    the selection state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### isEnabled

    public boolean isEnabled()

  Returns `true` if the receiver is enabled and all of the receiver's ancestors are enabled, and `false` otherwise. A disabled control is typically not selectable from the user interface and draws with an inactive or "grayed" look.

  Returns:
    the receiver's enabled state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `getEnabled()`

### removeArmListener

    public void removeArmListener(ArmListener listener)

  Removes the listener from the collection of listeners who will be notified when the arm events are generated for the control.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `ArmListener`, `addArmListener(org.eclipse.swt.events.ArmListener)`

### removeHelpListener

    public void removeHelpListener(HelpListener listener)

  Removes the listener from the collection of listeners who will be notified when the help events are generated for the control.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `HelpListener`, `addHelpListener(org.eclipse.swt.events.HelpListener)`

### removeSelectionListener

    public void removeSelectionListener(SelectionListener listener)

  Removes the listener from the collection of listeners who will be notified when the control is selected.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `SelectionListener`, `addSelectionListener(org.eclipse.swt.events.SelectionListener)`

### setAccelerator

    public void setAccelerator(int accelerator)

  Sets the widget accelerator. An accelerator is the bit-wise OR of zero or more modifier masks and a key. Examples: `SWT.MOD1 | SWT.MOD2 | 'T', SWT.MOD3 | SWT.F2`. `SWT.CONTROL | SWT.SHIFT | 'T', SWT.ALT | SWT.F2`.

  Parameters:
    `accelerator` - an integer that is the bit-wise OR of masks and a key
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setEnabled

    public void setEnabled(boolean enabled)

  Enables the receiver if the argument is `true`, and disables it otherwise. A disabled control is typically not selectable from the user interface and draws with an inactive or "grayed" look.

  Parameters:
    `enabled` - the new enabled state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setImage

    public void setImage(Image image)

  Sets the image the receiver will display to the argument.

  Note: This feature is not available on all window systems (for example, Window NT), in which case, calling this method will silently do nothing.

  Overrides:
    `setImage` in class `Item`
  Parameters:
    `image` - the image to display
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setMenu

    public void setMenu(Menu menu)

  Sets the receiver's pull down menu to the argument. Only `CASCADE` menu items can have a pull down menu. The sequence of key strokes, button presses and/or button releases that are used to request a pull down menu is platform specific.

  Parameters:
    `menu` - the new pull down menu
  Throws:
    `IllegalArgumentException` -
    - ERROR_MENU_NOT_DROP_DOWN - if the menu is not a drop down menu
    - ERROR_MENUITEM_NOT_CASCADE - if the menu item is not a `CASCADE`
    - ERROR_INVALID_ARGUMENT - if the menu has been disposed
    - ERROR_INVALID_PARENT - if the menu is not in the same widget tree
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setSelection

    public void setSelection(boolean selected)

  Sets the selection state of the receiver.

  When the receiver is of type `CHECK` or `RADIO`, it is selected when it is checked.

  Parameters:
    `selected` - the new selection state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setText

    public void setText(String string)

  Sets the receiver's text. The string may include the mnemonic character and accelerator text.

  Mnemonics are indicated by an '&' that causes the next character to be the mnemonic. When the user presses a key sequence that matches the mnemonic, a selection event occurs. On most platforms, the mnemonic appears underlined but may be emphasised in a platform specific manner. The mnemonic indicator character '&' can be escaped by doubling it in the string, causing a single '&' to be displayed.

  Accelerator text is indicated by the '\t' character. On platforms that support accelerator text, the text that follows the '\t' character is displayed to the user, typically indicating the key stroke that will cause the item to become selected. On most platforms, the accelerator text appears right aligned in the menu. Setting the accelerator text does not install the accelerator key sequence. The accelerator key sequence is installed using #setAccelerator.

  Overrides:
    `setText` in class `Item`
  Parameters:
    `string` - the new text
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the text is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `setAccelerator(int)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Guidelines for using Eclipse APIs.

Copyright (c) IBM Corp. and others 2000, 2004. All rights reserved.